
# Togl - a Tk OpenGL widget
# Copyright (C) 1996-1997  Brian Paul and Ben Bederson
# See the LICENSE file for copyright details.


#
# Test Togl using GL Gears Demo
#
# Copyright (C) 1997 Philip Quaife
#

proc setup {} {
    global startx starty xangle0 yangle0 xangle yangle RotCnt
    global vTime algorithm steps  runs initval explore
	set initval -1.0
    set RotCnt 1
    set xangle 0.0
    set yangle 0.0
    set vTime 100
	set steps 0
	set runs 1
    wm title . "Block World Learing"

	frame .info -borderwidth 5 -relief raised
	label .info.t -text "     Steps Taken:  "
	label .info.s -relief sunken -width 8 -text $steps
	pack .info.t -side left 
	pack .info.s -side left 
	label .info.t1 -text "     State Value:  "
	pack .info.t1 -side left 
	label .info.v -relief sunken -width 10 -text "0.00"
	pack .info.v -side left 
	label .info.t2 -text "     Runs:  "
	pack .info.t2 -side left 
	label .info.n -relief sunken -width 10 -text "0.000"
	pack .info.n -side left 
	pack .info -fill x

	frame .left  -borderwidth 10 -relief raised
	pack .left -fill x -side left

	frame .left.top  -borderwidth 1 
	pack .left.top -fill x -side top
    button .left.top.left -text "  Rerun  " -command ReRun
	pack .left.top.left -side left -fill x
    button .left.top.reset -text "  Reset  " -command ReSetBut 
	pack .left.top.reset -side right -fill x

	frame .left.top1  -borderwidth 1 
	pack .left.top1 -fill x -side top
	label .left.top1.l1 -text "Initial value of states:"
	entry .left.top1.initval -width 6 -textvariable initval 
	pack .left.top1.l1 .left.top1.initval -side left

	label .left.label2 -text "Algorithm"
	frame .left.sep2 -relief ridge -bd 1 -height 2 -width 10
	pack .left.label2 -side top
	pack .left.sep2 -side top -fill x -expand no


    radiobutton .left.man -text "Manual" -variable algorithm \
	-relief flat -value 1 -width 16 -anchor w -command RadioChange 
    pack .left.man  -side top -pady 2 -anchor w -fill x
#    radiobutton .left.rand -text "Random" -variable algorithm \
#	-relief flat -value 2 -width 16 -anchor w -command RadioChange 
#    pack .left.rand  -side top -pady 2 -anchor w -fill x
    radiobutton .left.learn -text "TD Learning (State Values)" -variable algorithm \
	-relief flat -value 3 -width 16 -anchor w -command RadioChange 
    pack .left.learn  -side top -pady 2 -anchor w -fill x
   radiobutton .left.lms -text "Q Learning" -variable algorithm \
	-relief flat -value 4 -width 16 -anchor w -command RadioChange 
    pack .left.lms  -side top -pady 2 -anchor w -fill x
   radiobutton .left.teach -text "Teach" -variable algorithm \
	-relief flat -value 5 -width 16 -anchor w -command RadioChange 
    pack .left.teach  -side top -pady 2 -anchor w -fill x
   radiobutton .left.learnteach -text "Learn from Teacher" -variable algorithm \
	-relief flat -value 6 -width 16 -anchor w -command RadioChange 
    pack .left.learnteach  -side top -pady 2 -anchor w -fill x
   radiobutton .left.run -text "Run Greedy" -variable algorithm \
	-relief flat -value 7 -width 16 -anchor w -command RadioChange 
    pack .left.run  -side top -pady 2 -anchor w -fill x
   radiobutton .left.expl -text "Q Explore" -variable algorithm \
	-relief flat -value 8 -width 16 -anchor w -command RadioChange 
    pack .left.expl  -side top -pady 2 -anchor w -fill x

	set algorithm 1


	label .left.label3 -text "Explore rate*100"
	scale .left.scale -orient horizontal -length 284 -from 0 -to 100 \
		-command "setExplore .left.canvas" -tickinterval 10
	pack .left.scale .left.label3 -side bottom -expand yes -anchor n
	.left.scale set 0
	set explore 0


    frame .f
    pack .f -side top -expand 1

	label .f.l1 -text "Number of runs to make:"
	entry .f.nr -width 5 -textvariable runs 
	pack .f.l1 .f.nr -side left

	label .f.l2 -text "      RMS Change:"
	label .f.err -relief sunken -width 8 -text "0.00"
	pack .f.l2 .f.err -side left

    button .f.n1 -text "  Save Image " -command saveIM
    button .f.b1 -text " Quit " -command exit 
    pack .f.n1 .f.b1 -side left -anchor w -padx 5
    newRot .w0 10
    bind . <Up> {Move 1}
    bind . <Down> {Move 2}
    bind . <Right> {Move 3}
    bind . <Left> {Move 4}

}

proc setExplore {w val} {
	global explore
	set explore $val
}

proc GUIUpdate { steps value truns rms_error} {
	.info.s configure -text $steps
	.info.v configure -text $value
	.info.n configure -text $truns
	.f.err configure -text $rms_error
}

proc ReRun { } {
	.w0 rerun 
}

proc ReSetBut { } {
	.w0 reset 
}

proc RadioChange { } {
	global  algorithm
#	.tglwin.w0 handleRadios  $algorithm
	.w0 handleRadios  $algorithm
}

proc Move {dirc} {
	global algorithm
	if {$algorithm == 1 || $algorithm == 5} {
		.w0 Manual $dirc
	}
}


proc saveIM {} {
	.w0 SavePPM
}

proc newRot {win {tick 100} } {
    togl $win -width 600 -height 600  -rgba true  -double true  -depth true -privatecmap false  -time $tick
    #bind $win <ButtonPress-1> {RotStart %x %y %W}
    #bind $win <B1-Motion> {RotMove %x %y %W}
    pack $win -expand true -fill both
}


proc RotMove {x y W} {
    global startx starty xangle0 yangle0 xangle yangle
        set xangle [expr $xangle0 + ($x - $startx)  ]
        set yangle [expr $yangle0 + ($y - $starty)  ]
        $W rotate $xangle $yangle
    }

setup
